## mariadb-10.6 10.6.9

=== debian/changelog ===
mariadb-10.6 (1:10.6.9-1) unstable; urgency=medium

  * New upstream version 10.6.8. Includes security fixes for
    - CVE-2018-25032
    - CVE-2022-32081
    - CVE-2022-32082
    - CVE-2022-32084
    - CVE-2022-32089
    - CVE-2022-32091

 -- Otto Kekäläinen <otto@debian.org>  Wed, 17 Aug 2022 07:28:05 -0700
